#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll mod = ll(1e9 + 7);

vector<vector<ll>> A;
ll n, m;

void f(ll x, ll y, vector<ll> V) {
    if (x == n - 1 && y == m - 1) {
        A.push_back(V);
        return;
    }
    if (x + 1 < n) {
        x++;
        V.push_back(1);
        f(x, y, V);
        V.pop_back();
        x--;
    }
    if (y + 1 < m) {
        y++;
        V.push_back(2);
        f(x, y, V);
        V.pop_back();
        y--;
    }
}


int main() {
    ll k; cin >> n >> m >> k;
    vector<pair<ll, ll>> K(k);
    for (ll i = 0; i < k; ++i) {
        ll x, y; cin >> x >> y;
        K[i] = {x - 1, y - 1};
    }
    f(0, 0, {});
    ll b = A.size();
    ll ans = 0;
    for (ll i = 0; i < b; ++i) {
        ll x = 0, y = 0;
        vector<ll> used1(k, 0), G(n * m, 0);
        for (ll j = 0; j < k; ++j) {
            if (K[j].first == 0 && K[j].second == 0) used1[j] = 1;
        }
        for (ll j = 0; j < n + m - 2; ++j) {
            if (A[i][j] == 1) x++;
            else y++;
            G[x * m + y] = 1;
            for (ll u = 0; u < k; ++u) {
                if (K[u].first == x && K[u].second == y) used1[u] = 1;
            }
        }

        for (ll j = 0; j < b; ++j) {
            vector<ll> used = used1;
            x = n - 1; y = m - 1;
            for (ll u = 0; u < k; ++u) {
                if (K[u].first == x && K[u].second == y) used[u] = 1;
            }
            ll p = 0;
            for (ll o = 0; o < n + m - 2; ++o) {
                if (A[j][o] == 1) x--;
                else y--;
                if (G[x * m + y]) {
                    p = 1;
                    break;
                }
                for (ll u = 0; u < k; ++u) {
                    if (K[u].first == x && K[u].second == y) used[u] = 1;
                }
            }

            if (!p && count(used.begin(), used.end(), 0) == 0) {
                ans++;
            }
        }
    }
    cout << ans;
}