#include <iostream>
#include <vector>
#include <string>


using namespace std;
using ll = long long;

const ll mod = ll(1e9 + 7);

const ll N = ll(1e5 + 5);
string ss;

int main() {
    for (ll i = 0; i < ll(1e5 + 5); ++i) ss += '0';
    ll n, s; cin >> n >> s;
    vector<vector<pair<ll, string>>> Dp(n);
    for (ll i = 0; i < n; ++i) {
        ll k; cin >> k;
        vector<ll> B(k);
        for (ll j = 0; j < k; ++j) cin >> B[j];
        vector<vector<pair<ll, string>>> A(k + 1, vector<pair<ll, string>>(s + 1, { 0, ss }));
        for (ll j = 0; j <= k; ++j) A[j][0] = { 1, ss };
        for (ll j = 1; j <= s; ++j) {
            for (ll u = 1; u <= k; ++u) {
                A[u][j] = A[u - 1][j];
                if (j - B[u - 1] >= 0 && A[u - 1][j - B[u - 1]].first) {
                    A[u][j] = A[u - 1][j - B[u - 1]];
                    string t = A[u][j].second;
                    t[u - 1] = '1';
                    A[u][j].second = t;
                }
            }
            if (A[k][j].first) Dp[i].push_back({ j, A[k][j].second });
        }
    }
    vector<pair<ll, vector<string>>> A;
    for (auto i : Dp[0]) {
        A.push_back({ i.first, {i.second} });
    }
    for (ll i = 1; i < n; ++i) {
        vector<pair<ll, vector<string>>> B;
        for (auto j : Dp[i]) {
            for (auto u : A) {
                ll w = u.first;
                vector<string> E = u.second;
                E.push_back(j.second);
                B.push_back({ j.first + u.first, E });
            }
        }
        A = B;
    }
    for (auto i : A) {
        if (i.first == s) {
            cout << "Yes" << '\n';

            for (string u : i.second) {
                ll cnt = 0;
                for (ll p = 0ll; p < u.size(); ++p) {
                    if (u[p] == '1') cnt++;
                }
                cout << cnt << '\n';
                for (ll p = 0ll; p < u.size(); ++p) {
                    if (u[p] == '1') cout << p + 1 << ' ';
                }
                cout << '\n';
            }
            return 0;
        }
    }
    cout << "No" << '\n';
}