#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
using ll = long long;

const ll mod = ll(1e9 + 7);

const ll N = ll(1e5 + 5);
vector<bool> ss(1e5 + 5, 0);

int main() {
    ll n, s; cin >> n >> s;

    if (n == 1) {
        ll k; cin >> k;
        vector<ll> A(k);
        for (ll i = 0; i < k; ++i) cin >> A[i];
        vector<vector<pair<ll, ll>>> Dp(k + 1, vector<pair<ll, ll>>(s + 1, {0, -1}));
        for (ll i = 0; i <= k; ++i) Dp[i][0].first = 1;
        for (ll i = 1; i <= s; ++i) {
            for (ll j = 1; j <= k; ++j) {
                Dp[j][i].first = Dp[j - 1][i].first;
                Dp[j][i].second = -1;
                if (i - A[j - 1] >= 0 && Dp[j - 1][i - A[j - 1]].first) {
                    Dp[j][i].first = 1;
                    Dp[j][i].second = j - 1;
                }
            }
        }
        ll x = k, y = s;
        vector<ll> ans;
        while (y > 0 && x > 0) {
            if (Dp[x][y].second == -1) {
                x--;
                continue;
            }
            ans.push_back(Dp[x][y].second + 1);
            y = ll(y - ll(A[Dp[x][y].second]));
            x--;
        }
        sort(ans.begin(), ans.end());
        cout << ans.size() << '\n';
        for (ll i : ans) {
            cout << i << ' ';
        }
        return 0;
    }

    vector<vector<pair<ll, vector<bool>>>> Dp(n);
    for (ll i = 0; i < n; ++i) {
        ll k; cin >> k;
        vector<ll> B(k);
        for (ll j = 0; j < k; ++j) cin >> B[j];
        vector<vector<pair<ll, vector<bool>>>> A(k + 1, vector<pair<ll, vector<bool>>>(s + 1, { 0, ss }));
        for (ll j = 0; j <= k; ++j) A[j][0] = { 1, ss };
        for (ll j = 1; j <= s; ++j) {
            for (ll u = 1; u <= k; ++u) {
                A[u][j] = A[u - 1][j];
                if (j - B[u - 1] >= 0 && A[u - 1][j - B[u - 1]].first) {
                    A[u][j] = A[u - 1][j - B[u - 1]];
                    vector<bool> t = A[u][j].second;
                    t[u - 1] = 1;
                    A[u][j].second = t;
                }
            }
            if (A[k][j].first) Dp[i].push_back({ j, A[k][j].second });
        }
    }
    vector<pair<ll, vector<vector<bool>>>> A;
    for (auto i : Dp[0]) {
        A.push_back({ i.first, {i.second} });
    }
    for (ll i = 1; i < n; ++i) {
        vector<pair<ll, vector<vector<bool>>>> B;
        for (auto j : Dp[i]) {
            for (auto u : A) {
                ll w = u.first;
                vector<vector<bool>> E = u.second;
                E.push_back(j.second);
                B.push_back({ j.first + u.first, E });
            }
        }
        A = B;
    }
    for (auto i : A) {
        if (i.first == s) {
            cout << "Yes" << '\n';

            for (vector<bool> u : i.second) {
                ll cnt = 0;
                for (ll p = 0ll; p < u.size(); ++p) {
                    if (u[p] == 1) cnt++;
                }
                cout << cnt << '\n';
                for (ll p = 0ll; p < u.size(); ++p) {
                    if (u[p] == 1) cout << p + 1 << ' ';
                }
                cout << '\n';
            }
            return 0;
        }
    }
    cout << "No" << '\n';
}